#include "testlib.h"

using namespace std;

typedef long long ll;

ll const LIM = 1000'000'000'000'000'000;

vector<pair<ll, ll>> readAnswer(InStream &in) {
    int k = in.readInt(0, 2, "k");
    vector<pair<ll, ll>> result;
    for (int i = 0; i < k; i++) {
        ll a = in.readLong(1, LIM, format("a_%d", i + 1));
        ll b = in.readLong(1, LIM, format("b_%d", i + 1));
        if (a > b) swap(a, b);
        result.emplace_back(a, b);
    }
    sort(result.begin(), result.end());
    return result;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    auto _ja = readAnswer(ans), pa = readAnswer(ouf);
    set<pair<ll, ll>> ja(_ja.begin(), _ja.end());

    if (ja.size() != pa.size())
        quitf(_wa, "Wrong number of options: participant has %s", ja.size() < pa.size() ? "more" : "less");
    for (auto const &opt: pa) {
        if (!ja.count(opt)) quitf(_wa, "Option (%lld, %lld) not found in jury's answer", opt.first, opt.second);
    }

    quitf(_ok, "Answers match");

}