#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = validator.group().empty() ? -1 : atoi(validator.group().c_str());

    string s = inf.readString("[a-z]{1,200000}", "s");
    inf.readEof();

    ensuref(s.size() <= 2 * 100'000, "|s|=%llu is greater than 2*10^5", s.size());

    if (group == 1) {
        ensuref(s.size() <= 10, "|s|=%llu is greater than 10 in group 1", s.size());
    } else if (group == 2) {
        for (int i = 0; i < s.size(); ++i) {
            ensuref('a' <= s[i] && s[i] <= 'b', "string contains not a or b character at pos %d in group 2", i);
        }
    } else if (group == 3) {
        for (int i = 0; i < s.size(); ++i) {
            ensuref('a' <= s[i] && s[i] <= 'c', "string contains not a or b or c character at pos %d in group 3", i);
        }
    } else if (group == 4) {
        ensuref(s.size() <= 1000, "|s|=%llu is greater than 1000 in group 4", s.size());
    }

    inf.readEof();

}