#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 200'000;
    int group = validator.group().size() ? atoi(validator.group().c_str()) : 0;

    int n = inf.readInt(1, N, "n");
    inf.readSpace();
    int k = inf.readInt(3, 5, "k");
    inf.readEoln();

    if (group == 1 || group == 2) ensuref(n <= 15, "Group condition n <= 15 unsatisfied, n = %d", n);
    if (group == 4) ensuref(n <= 100, "Group condition n <= 100 unsatisfied, n = %d", n);
    if (group == 5 || group == 6) ensuref(n <= 1000, "Group condition n <= 1000 unsatisfied, n = %d", n);

    if (group == 1 || group == 4 || group == 5) ensuref(k == 3, "Group condition k = 3 unsatisfied, k = %d", k);

    vector<int> deg(n);
    for (int i = 1; i < n; i++) {
        if (i > 1) inf.readSpace();
        int p = inf.readInt(1, n, format("p_%d", i + 1)) - 1;
        deg[p]++;
        ensuref(p < i, "Parent of %d should not be %d", i + 1, p + 1);
        if (group == 3) ensuref(deg[p] <= 2, "Group condition deg[v] <= 2 unsatisfied for v = %d", p + 1);
    }

    inf.readEoln();
    inf.readEof();

}